/*!
 * name: @jswork/next-underscored
 * description: Converts a camelized or dasherized string into an underscored one.
 * homepage: https://js.work
 * version: 1.0.1
 * date: 2024-02-27 08:06:32
 * license: MIT
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = void 0;
var _next = _interopRequireDefault(require('@jswork/next'));
function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : { default: obj };
}
var UNDERLINE = '_';
var dasherizeRE1 = /::/g,
  dasherizeRE2 = /([A-Z]+)([A-Z][a-z])/g,
  dasherizeRE3 = /([a-z\d])([A-Z])/g,
  dasherizeRE4 = /-/g,
  dasherizeRE5 = /\//g,
  dasherizeREPLACER = '$1-$2';
_next['default'].underscored = function (inStr) {
  return inStr
    .replace(dasherizeRE1, '/')
    .replace(dasherizeRE5, UNDERLINE)
    .replace(dasherizeRE2, dasherizeREPLACER)
    .replace(dasherizeRE3, dasherizeREPLACER)
    .replace(dasherizeRE4, UNDERLINE)
    .toLowerCase();
};
if (typeof module !== 'undefined' && module.exports && typeof wx === 'undefined') {
  module.exports = _next['default'].underscored;
}
var _default = (exports['default'] = _next['default'].underscored);
